package gui.settings;

import java.util.LinkedList;
import java.util.List;

import settings.Settings;
import settings.SettingsLoadable;

public class GUISettingsManager implements SettingsLoadable{
	private List<SettingsLoadable> settingsComps;
	
	public static final String X="X",Y="Y",W="Width",H="Height",STATE="WindowState";
	
	public GUISettingsManager() {
		settingsComps=new LinkedList<>();
	}

	public void addSettingsComponent(SettingsLoadable l) {
		settingsComps.add(l);
//		return (Component) l;
	}

	@Override
	public void loadSettings(Settings s) {
		for (SettingsLoadable l:settingsComps)
			l.loadSettings(s);
	}

	@Override
	public void saveSettings(Settings s) {
		for (SettingsLoadable l:settingsComps)
			l.saveSettings(s);
	}
	
	
	 
}
