package gui.settings;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import java.awt.Window;

import javax.swing.JDialog;

import settings.Settings;
import settings.SettingsLoadable;

import static gui.settings.GUISettingsManager.*;

public class SaveSettingsJDialog extends JDialog implements SettingsLoadable{

	private static final long serialVersionUID = -1549645362955664297L;

	private String settingsName;
	
	private void setSettingsName(String settingsName) {
		this.settingsName = settingsName;
	}
	
	@Override
	public void loadSettings(Settings s) {
		setBounds(
				s.getInt(settingsName+X),
				s.getInt(settingsName+Y),
				s.getInt(settingsName+W),
				s.getInt(settingsName+H)
		);
	}

	@Override
	public void saveSettings(Settings s) {
		s.set(settingsName+X, getX());
		s.set(settingsName+Y, getY());
		s.set(settingsName+W, getWidth());
		s.set(settingsName+H, getHeight());
	}

	public SaveSettingsJDialog(String settingsName) {
		super();
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Dialog owner, boolean modal, String settingsName) {
		super(owner, modal);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Dialog owner, String title, boolean modal, GraphicsConfiguration gc, String settingsName) {
		super(owner, title, modal, gc);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Dialog owner, String title, boolean modal, String settingsName) {
		super(owner, title, modal);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Dialog owner, String title, String settingsName) {
		super(owner, title);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Dialog owner, String settingsName) {
		super(owner);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Frame owner, boolean modal, String settingsName) {
		super(owner, modal);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Frame owner, String title, boolean modal, GraphicsConfiguration gc, String settingsName) {
		super(owner, title, modal, gc);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Frame owner, String title, boolean modal, String settingsName) {
		super(owner, title, modal);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Frame owner, String title, String settingsName) {
		super(owner, title);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Frame owner, String settingsName) {
		super(owner);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Window owner, ModalityType modalityType, String settingsName) {
		super(owner, modalityType);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Window owner, String title, ModalityType modalityType, GraphicsConfiguration gc, String settingsName) {
		super(owner, title, modalityType, gc);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Window owner, String title, ModalityType modalityType, String settingsName) {
		super(owner, title, modalityType);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Window owner, String title, String settingsName) {
		super(owner, title);
		setSettingsName(settingsName);
	}

	public SaveSettingsJDialog(Window owner, String settingsName) {
		super(owner);
		setSettingsName(settingsName);
	}

}
