package gui.settings;

import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;

import javax.swing.JFrame;

import settings.Settings;
import settings.SettingsLoadable;

import static gui.settings.GUISettingsManager.*;

public class SettingsFrame extends JFrame implements SettingsLoadable{

	private static final long serialVersionUID = -7029906283582386435L;

	private String settingsName;
	
	private void setSettingsName(String settingsName) {
		this.settingsName = settingsName;
	}
	
	public SettingsFrame(String settingsName) throws HeadlessException {
		setSettingsName(settingsName);
	}

	public SettingsFrame(GraphicsConfiguration gc,String settingsName) {
		super(gc);
		setSettingsName(settingsName);
	}

	public SettingsFrame(String title,String settingsName) throws HeadlessException {
		super(title);
		setSettingsName(settingsName);
	}

	public SettingsFrame(String title, GraphicsConfiguration gc,String settingsName) {
		super(title, gc);
		setSettingsName(settingsName);
	}

	
	
	@Override
	public void loadSettings(Settings s) {
		setBounds(
				s.getInt(settingsName+X),
				s.getInt(settingsName+Y),
				s.getInt(settingsName+W),
				s.getInt(settingsName+H)
		);
		setExtendedState(s.getInt(settingsName+STATE));
	}

	@Override
	public void saveSettings(Settings s) {
		s.set(settingsName+X, getX());
		s.set(settingsName+Y, getY());
		s.set(settingsName+W, getWidth());
		s.set(settingsName+H, getHeight());
		s.set(settingsName, getExtendedState());
	}

}
