/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.settings.dialog.page;

import java.awt.GridLayout;
import javax.swing.JPanel;

import core.io.Application;

import settings.Settings;

import gui.resource.ResourceManager;
import gui.settings.dialog.group.ProxySettingsGroup;
import gui.settings.dialog.group.TimeoutSettingsGroup;
import gui.settings.dialog.group.TriesSettingsGroup;

public class NetworkSettingsPage extends SettingsPage {

	private static final long serialVersionUID = -663846471713340432L;

	public static final String 
		SETTING_PROXY_ENABLED = "proxyEnabled",
		SETTING_PROXY_HOST = "proxyHost", 
		SETTING_PROXY_PORT = "proxyPort",
		SETTING_TIMEOUT = "timeout",
		SETTING_TRIES = "maxTries",
		LOCALE_PROXY_ENABLED = "settingProxyEnabled",
		LOCALE_PROXY_HOST = "settingProxyHost",
		LOCALE_PROXY_PORT = "settingProxyPort",
		LOCALE_TIMEOUT = "settingTimeout",
		LOCALE_TRIES = "settingTries"
	;

	public NetworkSettingsPage(String entry, Application app) {
		super(entry, app);
	}

	@Override
	protected void createComponentGroups(Settings settings, ResourceManager rm) {
		setLayout(new GridLayout(2, 1));
		JPanel p = new JPanel(new GridLayout(1, 2));
		addSettingsComponentGroup(new TimeoutSettingsGroup(rm), p, null);
		addSettingsComponentGroup(new TriesSettingsGroup(rm), p, null);
		add(p);
		addSettingsComponentGroup(new ProxySettingsGroup(rm));
	}
}
