/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package net.util;

import util.StringUtil;

public abstract class LinkExtractor {
	public abstract String getLink(String url,String html,String[] args);
	
	public abstract String[] getArgNames();
	
	public static char delimiter='\'';
	
	protected LinkExtractor() {
	}
	
	public static String preFilterHtml(String html) {
		return StringUtil.replaceAll(StringUtil.dropAll(html, '\u0020','\t','\r','\n'),'"','\'');
		
//		return html.replaceAll("\u0020|\t|\n|\r", "").replaceAll("\"", "'");
	}
	
	

	public static LinkExtractor getLinkExtractor(String type) {
		if (type!=null) {
			if (type.equals("id")) {
				return LinkExtractorById.getLinkExtractor();
			} else if (type.equals("key")) {
				return LinkExtractorByKey.getLinkExtractor();
			} else if (type.equals("keyNoDelimiter")) {
				return LinkExtractorByKeyNoDelimiter.getLinkExtractor();
			} else if (type.equals("htmlElement")) {
				return LinkExtractorByHtmlElement.getLinkExtractor();
			} else if (type.equals("js")) {
				return LinkExtractorJS.getLinkExtractor();
			} else if (type.equals("keyStartEnd")) {
				return LinkExtractorByKeyStartEnd.getLinkExtractor();
			} else if (type.equals("partialId")) {
				return LinkExtractorByPartialId.getLinkExtractor();
			} 
//			else if (type.startsWith("loadClass")) {
//				try {
//					return (LinkExtractor) Class.forName(type.substring(type.indexOf('@')+1)).newInstance();
//				} catch (InstantiationException e) {
//					e.printStackTrace();
//				} catch (IllegalAccessException e) {
//					e.printStackTrace();
//				} catch (ClassNotFoundException e) {
//					e.printStackTrace();
//				}
//			}
		}
		return null;
	}
}
